//	xExECZT[ BME280(I2C W[ GYBMEP)FeXg
//	wt]xH쎺	http://jsdiy.webcrow.jp

/*
y|[gΉz	ATtiny85		x:݂Ȃ(PB5RESET) -:
bit		7	6	5	4	3	2	1	0
portB	x	x	*	-	-	SCL	-	SDA		USI-TWI
							SCK	MISO MOSI

yATtiny85z
|-210|
|VBBB|
>    |
|BBBG|
|534-|

yq[Yrbgz(ftavrw.exe -rf)	Hoאݒ Lo: 01100010(62), Hi:11011111(DF)
Low: 01100010 (62)
     ||||++++-- CKSEL[3:0] VXeNbNI
     ||++-- SUT[1:0] N
     |+-- CKOUT (0:CLKOɃVXeNbNo)
     +-- CKDIV8 NbNl (1:1/1, 0:1/8)

High:11011111 (DF)
     |||||+++-- BODLEVEL[2:0] (111:Off, 110:1.8, 101:2.7, 100:4.3, 011:2.3, 010:2.2, 001:1.9, 000:2)
     ||||+-- EESAVE (ChipEEPROM 0:ێ, 1:)
     |||+-- WDTON (WDT 0:펞ON, 1:ʏ)
     ||+-- SPIEN (1:ISP֎~, 0:ISP) HVŜ
     |+-- DWEN (On-ChipfobO 1:, 0:L)
     +-- RSTDISBL (RESETs 1:L, 0:(PORT))

Ext: -------1 (FF)
	        +-- SELFPRGEN f[^V[gQ
*/
/*
yrhz
Atmel Studio 7 (Version: 7.0.1417 - )
ATtiny85  1MHzi8MHz/8j

yXVz
2017/06/18	v1.00	
	Program Memory Usage 	:	3782 bytes   46.2 % Full
	Data Memory Usage 		:	74 bytes   14.5 % Full

2017/06/20	v1.10
	EԌvɃ^C}[^JE^𗘗p
	EsleepȂǂŏȓd͉
	Program Memory Usage 	:	3920 bytes   47.9 % Full
	Data Memory Usage 		:	74 bytes   14.5 % Full
	
2017/09/07	v1.20	twiclcdŐVłɕύX
	Program Memory Usage 	:	3780 bytes   46.1 % Full
	Data Memory Usage 		:	74 bytes   14.5 % Full
*/

#include <avr/io.h>
#include <avr/sleep.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "twilib.h"
#include "twiclcd/I2cCharLcdLib.h"
#include "bme280lib.h"

static	void	PutSensorValue(const TBme280IntDec* val, const char* unit);
static	void	SleepSec(uint16_t sec);


ISR(TIMER0_OVF_vect)
{
	//sleep
}

int main(void)
{
	uint8_t i;
	uint16_t	loopCount = 0;
	TBme280Value sensorValue;

	//d҂^Ӌ@̋N҂
	for (i = 0; i < 10; i++) { _delay_ms(100); }	//1b

	//d͍팸i'1'ŋ@\~j
	PRR = (1<<PRTIM1)|(0<<PRTIM0)|(0<<PRUSI)|(1<<PRADC);
	ACSR = (1<<ACD);

	//gpsvAbv
	PORTB |=   (1<<PB1)|(1<<PB3)|(1<<PB4);
	DDRB  &= ~((1<<PB1)|(1<<PB3)|(1<<PB4));
	
	//^C}[^JE^ݒ (Timer/Counter0 Overflow)
	//EW -> TCCR0B:WGM02 / TCCR0A:WGM01 / TCCR0A:WGM00 = 000
	//E1024 -> TCCR0B:CS02 / TCCR0B:CS01 / TCCR0B:CS00 = 101
	//E1MHz / 1024 = 976.5625JEg1b
	//	255JEgŃI[o[t[荞ݔ -> 976.5625JEg / 255JEg = 0.261b/ovf
	//	600b / 0.261b = 2297.8ovf -> I[o[t[2298Ŗ600b(599.8b)
	TCCR0A = (0<<WGM01)|(0<<WGM00);
	TCCR0B = (0<<WGM02)|(1<<CS02)|(0<<CS01)|(1<<CS00);
	TIMSK = (1<<TOIE0);
	TIFR = (1<<TOV0);


	TWI_MasterInit();
	
	I2CLCD_Init(I2CLCD_DEFAULT_SLA, 16, 2);
	I2CLCD_SetLineMode(LCD_LINEMODE_COMBINE | LCD_LINEMODE_OVERWRITE, LCD_CURSOR_ON);
	
	if (!BME280_Init())
	{
		I2CLCD_PutString("InitErr.");
		goto FINISH;
	}

	BME280_PresetPattern(BME280_PATTERN_WeatherMonitoring);

	sei();
	while (1)
	{
		BME280_GetSensorValue(&sensorValue);

		I2CLCD_Clear();
		I2CLCD_SetPos(0, 0);
		PutSensorValue(&sensorValue.temperature, "'C");

		I2CLCD_SetPos(0, 8);
		PutSensorValue(&sensorValue.humidity, "%RH");
	
		I2CLCD_SetPos(1, 0);
		PutSensorValue(&sensorValue.pressure, "hPa");

		I2CLCD_SetPos(1, 11);
		I2CLCD_PutWord(loopCount++);

		SleepSec(60);
	}

FINISH:
	return 0;
}

static	void	PutSensorValue(const TBme280IntDec* val, const char* unit)
{
	I2CLCD_PutInt(val->integer);
	I2CLCD_PutChar('.');
	if (val->decimal < 10) { I2CLCD_PutChar('0'); }
	I2CLCD_PutUInt(val->decimal);
	I2CLCD_PutString(unit);
}

static	void	SleepSec(uint16_t sec)
{
	uint16_t	maxCount = (uint16_t)(sec / 0.261 + 0.5);	// 0.261b/ovf
	uint16_t	ovfCount = 0;

	while (ovfCount++ < maxCount)
	{
		set_sleep_mode(SLEEP_MODE_IDLE);
		sleep_mode();
	}
}
