//	LN^LCD I2CA_v^F}X^[Cu
//	wt]xH쎺	http://jsdiy.webcrow.jp
//	2017/08	
//	2017/09	ESendByteXXX()̖߂liیʁjp~B
//			EI2CLCD_PutWord()SendByteBlock()ďoSendByteP2()ɕύXB

#include <avr/io.h>
#include <avr/pgmspace.h>
#include "I2cCharLcdLib.h"
#include "../twilib.h"

#define HiByte(w)	(((w) >> 8) & 0xFF)
#define LoByte(w)	((w) & 0xFF)

#define SLA_W_BIT	0
#define SLA_R_BIT	1

static uint8_t	SlaveAddress = I2CLCD_DEFAULT_SLA;

//Rg[oCg1̃f[^oCg𑗐M
static	void	SendByteP1(uint8_t ctrlByte, uint8_t dataByte)
{
	TWI_Start();
	TWI_SlaveAddrW(SlaveAddress);
	TWI_WriteByte(ctrlByte);
	TWI_WriteByte(dataByte);
	TWI_Stop();
}

//Rg[oCg2̃f[^oCg𑗐M
static	void	SendByteP2(uint8_t ctrlByte, uint8_t dataByte1, uint8_t dataByte2)
{
	TWI_Start();
	TWI_SlaveAddrW(SlaveAddress);
	TWI_WriteByte(ctrlByte);
	TWI_WriteByte(dataByte1);
	TWI_WriteByte(dataByte2);
	TWI_Stop();
}

//Rg[oCgƃf[^oCg̔z𑗐M
static	void	SendByteBlock(uint8_t ctrlByte, const uint8_t* dataBytes, uint8_t length)
{
	uint8_t	i;
	
	TWI_Start();
	TWI_SlaveAddrW(SlaveAddress);
	for (i = 0; i < length; i++)
	{
		TWI_WriteByte(ctrlByte);
		TWI_WriteByte(dataBytes[i]);
	}
	TWI_Stop();
}

//ΏۂLCDfoCX
//E{foCX̓X[uAhXςI2CoXɕڑ邱ƂłB
//	ꂼ̃foCXɑ΂Ă̊֐ĂяoKvB
//EI2CoXɖ{foCX1ڑĂȂꍇÅ֐1ĂяoΏ\B
void	I2CLCD_Init(uint8_t slaveAddress, uint8_t columnSize, uint8_t rowSize)
{
	I2CLCD_SlaveSelect(slaveAddress);
	SendByteP2(LCD_FUNC_INIT, columnSize, rowSize);
}

//ΏۂLCDfoCX؂ւ
//E{foCX̓X[uAhXςI2CoXɕڑ邱ƂłB
//	̏ꍇɁAǂLCDfoCX𑀍삷̂A̓sx̊֐Ő؂ւB
//EI2CoXɖ{foCX1ڑĂȂꍇÅ֐Ăяoʂ͂ȂB
void	I2CLCD_SlaveSelect(uint8_t slaveAddress)
{
	SlaveAddress = slaveAddress;
}

//HD44780x̃R}h𑗐MiڍׂHD44780̃f[^V[g̃R}hꗗQƁj
void	I2CLCD_SendCmd(uint8_t cmd)
{
	SendByteP1(RS_CMD, cmd);
}

//HD44780x̃f[^𑗐MiڍׂHD44780̃f[^V[g̃R}hꗗQƁj
void	I2CLCD_SendData(uint8_t data)
{
	SendByteP1(RS_DATA, data);
}

//s\̓Zbg
void	I2CLCD_SetLineMode(uint8_t lineMode, uint8_t cursorFlag)
{
	SendByteP2(LCD_FUNC_SETLINEMODE, lineMode, cursorFlag);
}

//̕\ʒuZbg
void	I2CLCD_SetPos(uint8_t row_y, uint8_t column_x)
{
	SendByteP2(LCD_FUNC_SETPOS_XY, column_x, row_y);
}

//LCDʂ
void	I2CLCD_Clear()
{
	I2CLCD_SendCmd(LCD_CMD_CLEAR_DISPLAY);
}

//1\
void	I2CLCD_PutChar(char cc)
{
	SendByteP1(LCD_FUNC_PUTCHAR, cc);
}

//\
//ExɑMł镶 (UINT8_MAX - 1) ܂ŁB
void	I2CLCD_PutString(const char* str)
{
	uint8_t length;
	for (length = 0; str[length] != '\0'; length++);
	SendByteBlock(LCD_FUNC_PUTCHAR, (uint8_t*)str, length);
}

//vÖɊi[ꂽ\
//ExɑMł镶 (UINT8_MAX - 1) ܂ŁB
void	I2CLCD_PutStringP(const char* strpgm)
{
	uint8_t cc;
	
	TWI_Start();
	TWI_SlaveAddrW(SlaveAddress);
	while ((cc = pgm_read_byte(strpgm++)) != '\0')
	{
		TWI_WriteByte(LCD_FUNC_PUTCHAR);
		TWI_WriteByte(cc);
	}
	TWI_Stop();
}

//萮\i10ij	8bit/16bitp
void	I2CLCD_PutInt(int16_t n)
{
	SendByteP2(LCD_FUNC_PUTINT, HiByte(n), LoByte(n));
}

//Ȃ\i10ij	8bit/16bitp
void	I2CLCD_PutUInt(uint16_t n)
{
	SendByteP2(LCD_FUNC_PUTUINT, HiByte(n), LoByte(n));
}

//0l216i\	ړ'0x'ڔ'h'͕tȂ
void	I2CLCD_PutByte(uint8_t n)
{
	SendByteP1(LCD_FUNC_PUTBYTE, n);
}

//0l416i\	ړ'0x'ڔ'h'͕tȂ
void	I2CLCD_PutWord(uint16_t n)
{
	SendByteP2(LCD_FUNC_PUTWORD, HiByte(n), LoByte(n));
}

//[U[`iڍׂHD44780̃f[^V[g̃R}hꗗQƁj
//id:	0-7iLN^R[hj
//dots:	uint8_t[8]i5x8̃hbgp^[j
void	I2CLCD_DefChar(uint8_t id, const uint8_t* dots)
{
	uint8_t	i;
	for (i = 0; i < 8; i++)
	{
		I2CLCD_SendCmd(LCD_CMD_SET_CGRAM_ADRS | (id << 3) | i);
		I2CLCD_SendData(dots[i]);
	}
}
